searchNodes=[{"doc":"Use cellular modems with VintageNet This module is not intended to be called directly but via calls to VintageNet. Here&#39;s a typical example: VintageNet.configure( &quot;ppp0&quot;, %{ type: VintageNetMobile, modem: your_modem, modem_opts: %{}, service_providers: your_service_providers } ) The :modem key should be set to your modem implementation. Cellular modems tend to be very similar. If vintage_net_mobile doesn&#39;t list your modem, see the customizing section. It may just be a copy/paste away. See your module for your modem for what options can be passed to :modem_opts. The :service_providers key should be set to information provided by each of your service providers. It is common that this is a list of one item. Circumstances may require you to list more than one, though. Additionally, modem implementations may require more or less information depending on their implementation. (It&#39;s possible to hard-code the service provider in the modem implementation. In that case, this key isn&#39;t used and should be set to an empty list. This is useful when your cellular modem provides instructions that magically work and the AT commands that they give are confusing.) Information for each service provider is a map with some or all of the following fields: :apn (required) - e.g., &quot;access_point_name&quot; :usage (optional) - :eps_bearer (LTE) or :pdp (UMTS/GPRS) Your service provider should provide you with the information that you need to connect. Often it is just an APN. The Gnome project provides a database of service provider information that may also be useful. Here&#39;s an example with a service provider list: %{ type: VintageNetMobile, modem: your_modem, service_providers: [ %{apn: &quot;wireless.twilio.com&quot;} ] } Custom modems VintageNetMobile allows you add custom modem implementations if the built-in ones don&#39;t work for you. See the VintageNetMobile.Modem behaviour. In order to implement a modem, you will need: Instructions for connecting to the modem via your Linux. Sometimes this involves usb_modeswitch or knowing which serial ports the modem exposes. Example chat scripts. These are lists of AT commands and their expected responses for configuring the service provider and entering PPP mode. (Optional) Instructions for checking the signal strength when connected. One strategy is to see if there&#39;s an existing modem that looks similar to yours and modify it.","ref":"VintageNetMobile.html","title":"VintageNetMobile","type":"module"},{"doc":"Information about a service provider :apn (required) - e.g., &quot;access_point_name&quot; :usage (optional) - :eps_bearer (LTE) or :pdp (UMTS/GPRS)","ref":"VintageNetMobile.html#t:service_provider_info/0","title":"VintageNetMobile.service_provider_info/0","type":"type"},{"doc":"A behaviour for modem implementations","ref":"VintageNetMobile.Modem.html","title":"VintageNetMobile.Modem","type":"behaviour"},{"doc":"Update the raw configuration for the modem The incoming raw configuration (first parameter) will have an initial generic configuration that should be common to most modems. The second parameter is the normalized VintageNet configuration and the final options are the ones from VintageNet for determining file paths, etc. Configuration errors raise exceptions, but it is good practice to catch the errors in normalize/1.","ref":"VintageNetMobile.Modem.html#c:add_raw_config/3","title":"VintageNetMobile.Modem.add_raw_config/3","type":"callback"},{"doc":"Normalize a modem configuration Modem implementations use this to update the :modem_opts key to a canonical representation. This could be adding default fields, migrating old options, or deriving parameters to that they need not be computed again. Configuration errors raise exceptions.","ref":"VintageNetMobile.Modem.html#c:normalize/1","title":"VintageNetMobile.Modem.normalize/1","type":"callback"},{"doc":"Check to make sure the modem is ready to be used","ref":"VintageNetMobile.Modem.html#c:ready/0","title":"VintageNetMobile.Modem.ready/0","type":"callback"},{"doc":"Quectel BG96 support The Quectel BG96 is an LTE Cat M1/Cat NB1/EGPRS module. Here&#39;s an example configuration: VintageNet.configure( &quot;ppp0&quot;, %{ type: VintageNetMobile, vintage_net_mobile: %{ modem: VintageNetMobile.Modem.QuectelBG96, service_providers: [%{apn: &quot;super&quot;}] } } ) If multiple service providers are configured, this implementation only attempts to connect to the first one. The following modem-specific keys are also supported in the :vintage_net_mobile map: :scan - Set this to the order that radio access technologies should be attempted when trying to connect. For example, [:lte_cat_m1, :gsm] would prevent the modem from trying LTE Cat NB1 and potentially save some time if you&#39;re guaranteed to not have Cat NB1 service. Required Linux kernel options CONFIG_USB_SERIAL=m CONFIG_USB_SERIAL_WWAN=m CONFIG_USB_SERIAL_OPTION=m CONFIG_USB_WDM=m CONFIG_USB_NET_QMI_WWAN=m","ref":"VintageNetMobile.Modem.QuectelBG96.html","title":"VintageNetMobile.Modem.QuectelBG96","type":"module"},{"doc":"Radio Access Technology (RAT) These define how to connect to the cellular network.","ref":"VintageNetMobile.Modem.QuectelBG96.html#t:rat/0","title":"VintageNetMobile.Modem.QuectelBG96.rat/0","type":"type"},{"doc":"Quectel EC25 support The Quectel EC25 is a series of LTE Cat 4 modules. Here&#39;s an example configuration: VintageNet.configure( &quot;ppp0&quot;, %{ type: VintageNetMobile, vintage_net_mobile: %{ modem: VintageNetMobile.Modem.QuectelEC25, service_providers: [%{apn: &quot;wireless.twilio.com&quot;}] } } ) If multiple service providers are configured, this implementation only attempts to connect to the first one. Required Linux kernel options CONFIG_USB_SERIAL=m CONFIG_USB_SERIAL_WWAN=m CONFIG_USB_SERIAL_OPTION=m CONFIG_USB_WDM=m CONFIG_USB_NET_QMI_WWAN=m","ref":"VintageNetMobile.Modem.QuectelEC25.html","title":"VintageNetMobile.Modem.QuectelEC25","type":"module"},{"doc":"Sierra Wireless HL8548 modem https://source.sierrawireless.com/resources/airprime/hardware_specs_user_guides/airprime_hl8548_and_hl8548-g_product_technical_specification/ The Sierra Wireless HL8548 is an industrial grade Embedded Wireless Module that provides voice and data connectivity on GPRS, EDGE, WCDMA, HSDPA and HSUPA networks. Here&#39;s an example configuration: VintageNet.configure( &quot;ppp0&quot;, %{ type: VintageNetMobile, vintage_net_mobile: %{ modem: VintageNetMobile.Modem.SierraHL8548, service_providers: [%{apn: &quot;BROADBAND&quot;}] } } )","ref":"VintageNetMobile.Modem.SierraHL8548.html","title":"VintageNetMobile.Modem.SierraHL8548","type":"module"},{"doc":"ublox TOBY-L2 support The ublox TOBY-L2 is a series of LTE Cat 4 modules with HSPA+ and/or 2G fallback. Here&#39;s an example configuration: VintageNet.configure( &quot;ppp0&quot;, %{ type: VintageNetMobile, vintage_net_mobile: %{ modem: VintageNetMobile.Modem.UbloxTOBYL2, service_providers: [ %{apn: &quot;lte-apn&quot;, usage: :eps_bearer}, %{apn: &quot;old-apn&quot;, usage: :pdp} ] } } ) This implementation currently requires APNs to be annotated for whether they are to be used on LTE (:eps_bearer) or on UMTS/GPRS (:pdp). Required Linux kernel options CONFIG_USB_SERIAL=m CONFIG_USB_SERIAL_WWAN=m CONFIG_USB_SERIAL_OPTION=m","ref":"VintageNetMobile.Modem.UbloxTOBYL2.html","title":"VintageNetMobile.Modem.UbloxTOBYL2","type":"module"},{"doc":"VintageNetMobile This library provides a VintageNet technology for using cellular modems. Currently, it supports the following modems: Quectel BG96 - VintageNetMobile.Modem.QuectelBG96 Quectel EC25 - VintageNetMobile.Modem.QuectelEC25 ublox TOBY L2 - VintageNetMobile.Modem.UbloxTOBYL2 Sierra Wireless HL8548 - VintageNetMobile.Modem.SierraHL8548 See the &quot;Custom Modems&quot; section for adding new modules. To use this library, first add it to your project&#39;s dependency list: def deps do [ {:vintage_net_mobile, &quot;~&gt; 0.1.2&quot;} ] end You will then need to configure VintageNet. All cellular modems currently show up on &quot;ppp0&quot;, so configurations look like this: VintageNet.configure(&quot;ppp0&quot;, %{ type: VintageNetMobile, vintage_net_mobile: %{ modem: your_modem, service_providers: your_service_providers } }) The :modem key should be set to your modem implementation. Cellular modems tend to be very similar. If vintage_net_mobile doesn&#39;t support your modem, see the customizing section. It may just be a copy/paste away. The :service_providers key should be set to information provided by each of your service providers. It is common that this is a list of one item. Circumstances may require you to list more than one, though. Additionally, modem implementations may require more information. (It&#39;s also possible to hard-code the service provider in the modem implementation as a hack. In that case, this key isn&#39;t used and should be set to an empty list. This is useful when your cellular modem provides instructions that magically work and the AT commands that they give are confusing.) Information for each service provider is a map with some or all of the following fields: :apn (required) - e.g., &quot;access_point_name&quot; :usage (optional) - :eps_bearer (LTE) or :pdp (UMTS/GPRS) Your service provider should provide you with the information that you need to connect. Often it is just an APN. The Gnome project provides a database of service provider information that may also be useful. Here&#39;s an example with a service provider list: %{ type: VintageNetMobile, vintage_net_mobile: %{ modem: your_modem, service_providers: [ %{apn: &quot;wireless.twilio.com&quot;} ] } }","ref":"readme.html","title":"VintageNetMobile","type":"extras"},{"doc":"VintageNetMobile allows you add custom modem implementations if the built-in ones don&#39;t work for you. See the VintageNetMobile.Modem behaviour. In order to implement a modem, you will need: Instructions for connecting to the modem via your Linux. Sometimes this involves usb_modeswitch or knowing which serial ports the modem exposes. Example chat scripts. These are lists of AT commands and their expected responses for configuring the service provider and entering PPP mode. (Optional) Instructions for checking the signal strength when connected. One strategy is to see if there&#39;s an existing modem that looks similar to yours and modify it.","ref":"readme.html#custom-modems","title":"VintageNetMobile - Custom modems","type":"extras"},{"doc":"These requirements are believed to be the minimum needed to be added to the official Nerves systems. Linux kernel Enable PPP and drivers for your modem: CONFIG_PPP=m CONFIG_PPP_BSDCOMP=m CONFIG_PPP_DEFLATE=m CONFIG_PPP_FILTER=y CONFIG_PPP_MPPE=m CONFIG_PPP_MULTILINK=y CONFIG_PPP_ASYNC=m CONFIG_PPP_SYNC_TTY=m CONFIG_USB_NET_CDC_NCM=m CONFIG_USB_NET_HUAWEI_CDC_NCM=m CONFIG_USB_NET_QMI_WWAN=m CONFIG_USB_SERIAL_OPTION=m Buildroot (nerves_defconfig) Both pppd and usb_modeswitch are needed in the nerves_defconfig: BR2_PACKAGE_USB_MODESWITCH=y BR2_PACKAGE_PPPD=y BR2_PACKAGE_PPPD_FILTER=y Busybox Add the following to your nerves_defconfig: BR2_PACKAGE_BUSYBOX_CONFIG_FRAGMENT_FILES=&quot;${NERVES_DEFCONFIG_DIR}/busybox.fragment&quot; and then create busybox.fragment with the following: CONFIG_MKNOD=y CONFIG_WC=y","ref":"readme.html#system-requirements","title":"VintageNetMobile - System requirements","type":"extras"},{"doc":"In addition to the common vintage_net properties for all interface types, this technology reports the following: PropertyValuesDescription signal_rssi0-31 or 99An integer between 0-31 or 99","ref":"readme.html#vintagenet-properties","title":"VintageNetMobile - VintageNet Properties","type":"extras"},{"doc":"If you are running this on a nerves device and have elixircom installed: iex&gt; Elixircom.run(&quot;/dev/ttyUSB2&quot;, speed: 115200) Will allow you to run AT commands. To test everything is okay: iex&gt; Elixircom.run(&quot;/dev/ttyUSB2&quot;, speed: 115200) # type at and press enter OK CommandDescription at+csqSignal Strength at+csq=?Query supported signal strength format at+cfun?Level of functionality at+cfun=?Query supported functionality levels at+creg?Check if the modem has registered to a provider. at+cgreg?Same as above for some modems VintageNetMobile makes it easy to add cellular support to your device.","ref":"readme.html#serial-at-command-debugging","title":"VintageNetMobile - Serial AT command debugging","type":"extras"}]